/*************************************************************************
 * Myricom MPICH-MX ch_mx backend                                        *
 * Copyright (c) 2003 by Myricom, Inc.                                   *
 * All rights reserved.                                                  *
 *************************************************************************/

#ifndef _mxmpi_inline_h
#define _mxmpi_inline_h

/*
 * Inline functions
 */
static inline void 
mxmpi_malloc_assert(void * ptr, char * fct, char * msg)
{
  if (ptr == NULL)
    {
      fprintf(stderr, "[%d]: alloc failed, not enough memory (Fatal Error)\n"
	      "Context: <(%s) %s>\n", MPID_MyWorldRank, fct, msg);
      mxmpi_abort (0);
    }
}

static inline int
mxmpi_status_to_mpi_code(mx_status_code_t code)
{
  switch (code) {
  case MX_STATUS_SUCCESS:
    return MPI_SUCCESS;
  case MX_STATUS_TRUNCATED:
    return MPI_ERR_TRUNCATE;
  default:
    return MPI_ERR_UNKNOWN;
  }
}


#endif /* _mxmpi_inline_h */
