/*************************************************************************
 * Myricom MPICH-MX ch_mx backend                                        *
 * Copyright (c) 2003 by Myricom, Inc.                                   *
 * All rights reserved.                                                  *
 *************************************************************************/

#ifndef _mxmpi_debug_dma_memory_h
#define _mxmpi_debug_dma_memory_h

extern unsigned long mem_locked_total;
extern unsigned long mem_locked_in_use;

#if MXMPI_DEBUG_DMA_MEMORY

void mxmpi_debug_dma_memory_alloc(void *ptr, unsigned long length);
void mxmpi_debug_dma_memory_free(void *ptr);
void mxmpi_debug_dma_memory_acquire(unsigned long size);
void mxmpi_debug_dma_memory_release(unsigned long size);
void mxmpi_debug_dma_memory_use(unsigned long size);
void mxmpi_debug_dma_memory_unse(unsigned long size);
void mxmpi_debug_dma_memory_final(unsigned long static_mem_size);


#define MXMPI_DEBUG_DMA_MEMORY_ALLOC(ptr,length) \
mxmpi_debug_dma_memory_alloc(ptr,length)
#define MXMPI_DEBUG_DMA_MEMORY_FREE(ptr) \
mxmpi_debug_dma_memory_free(ptr)
#define MXMPI_DEBUG_DMA_MEMORY_ACQUIRE(size) \
mxmpi_debug_dma_memory_acquire(size)
#define MXMPI_DEBUG_DMA_MEMORY_RELEASE(size) \
mxmpi_debug_dma_memory_acquire(size)
#define MXMPI_DEBUG_DMA_MEMORY_USE(size) \
mxmpi_debug_dma_memory_use(size)
#define MXMPI_DEBUG_DMA_MEMORY_UNUSE(size) \
mxmpi_debug_dma_memory_unuse(size)
#define MXMPI_DEBUG_DMA_MEMORY_FINAL(static_size) \
mxmpi_debug_dma_memory_final(static_size)
#else
#define MXMPI_DEBUG_DMA_MEMORY_ALLOC(ptr,length)
#define MXMPI_DEBUG_DMA_MEMORY_FREE(ptr)
#define MXMPI_DEBUG_DMA_MEMORY_ACQUIRE(size)
#define MXMPI_DEBUG_DMA_MEMORY_RELEASE(size)
#define MXMPI_DEBUG_DMA_MEMORY_USE(size)
#define MXMPI_DEBUG_DMA_MEMORY_UNUSE(size)
#define MXMPI_DEBUG_DMA_MEMORY_FINAL(static_size)
#endif

#endif
