/*************************************************************************
 * Myricom MPICH-MX ch_mx backend                                        *
 * Copyright (c) 2003 by Myricom, Inc.                                   *
 * All rights reserved.                                                  *
 *************************************************************************/

#include "mxmpi.h"


void mxmpi_debug_fifo_send_add(unsigned int put, 
			      unsigned int reg, 
			      unsigned int total)
{
  if (put)
    {
      fprintf(mxmpi.debug_output_filedesc, 
	      "[%d]: ADD one entry (PUT) to FIFO send "
	      "(Total = %d, ST=%d/%d)\n", MPID_MyWorldRank, total, 
	      mxmpi.send_tokens, mxmpi.max_send_tokens);
    }
  else
    {
      if (reg)
	{
	  fprintf(mxmpi.debug_output_filedesc, 
		  "[%d]: ADD one entry (SMALL+reg) to FIFO send "
		  "(Total = %d, ST=%d/%d)\n", MPID_MyWorldRank, total, 
		  mxmpi.send_tokens, mxmpi.max_send_tokens);
	}
      else
	{
	  fprintf(mxmpi.debug_output_filedesc, 
		  "[%d]: ADD one entry (SMALL) to FIFO send "
		  "(Total = %d, ST=%d/%d)\n", MPID_MyWorldRank, total, 
		  mxmpi.send_tokens, mxmpi.max_send_tokens);
	}
    }
  fflush(mxmpi.debug_output_filedesc);
}


void mxmpi_debug_fifo_send_remove(unsigned int put, unsigned int total)
{
  if (put)
    {
      fprintf(mxmpi.debug_output_filedesc, 
	      "[%d]: REMOVE one entry (PUT) from FIFO send "
	      "(Total = %d, ST=%d/%d)\n", MPID_MyWorldRank, total, 
	      mxmpi.send_tokens, mxmpi.max_send_tokens);
    }
  else
    {
      fprintf(mxmpi.debug_output_filedesc, 
	      "[%d]: REMOVE one entry (SMALL) from FIFO send "
	      "(Total = %d, ST=%d/%d)\n", MPID_MyWorldRank, total, 
	      mxmpi.send_tokens, mxmpi.max_send_tokens);
    }
  fflush(mxmpi.debug_output_filedesc);
}
