/*************************************************************************
 * Myricom MPICH-MX ch_mx backend                                        *
 * Copyright (c) 2003 by Myricom, Inc.                                   *
 * All rights reserved.                                                  *
 *************************************************************************/

#ifndef _mxmpi_debug_registration_h
#define _mxmpi_debug_registration_h


typedef struct _reg_segment
{
  struct _reg_segment * prev;
  struct _reg_segment * next;
  unsigned long start;
  unsigned long length;
} reg_segment;



#if MXMPI_DEBUG_REGISTRATION


void mxmpi_debug_registration_use_segment(unsigned long start,
					 unsigned long length);
void mxmpi_debug_registration_unuse_segment(unsigned long start,
					   unsigned long length);
void mxmpi_debug_registration_check_segment(unsigned long start,
					   unsigned long length,
					   char * context);
void mxmpi_debug_registration_clear_segment(unsigned long start,
					   unsigned long length);
void mxmpi_debug_registration_clear_all_segments(void);
void mxmpi_debug_registration_check_align(char * msg, unsigned long start,
					 unsigned long length);

     
#define MXMPI_DEBUG_REGISTRATION_USE_SEGMENT(start,length)       \
mxmpi_debug_registration_use_segment(start,length)
#define MXMPI_DEBUG_REGISTRATION_UNUSE_SEGMENT(start,length)     \
mxmpi_debug_registration_unuse_segment(start,length)
#define MXMPI_DEBUG_REGISTRATION_CHECK_SEGMENT(start,length,msg) \
mxmpi_debug_registration_check_segment(start,length,msg)
#define MXMPI_DEBUG_REGISTRATION_CLEAR_SEGMENT(start,length)     \
mxmpi_debug_registration_clear_segment(start,length)
#define MXMPI_DEBUG_REGISTRATION_CLEAR_ALL_SEGMENTS()            \
mxmpi_debug_registration_clear_all_segments()
#define MXMPI_DEBUG_REGISTRATION_CHECK_ALIGN(msg,ptr,len)        \
mxmpi_debug_registration_check_align(msg,ptr,len)
#else
#define MXMPI_DEBUG_REGISTRATION_USE_SEGMENT(start,length)
#define MXMPI_DEBUG_REGISTRATION_UNUSE_SEGMENT(start,length)
#define MXMPI_DEBUG_REGISTRATION_CHECK_SEGMENT(start,length,msg)
#define MXMPI_DEBUG_REGISTRATION_CLEAR_SEGMENT(start,length)
#define MXMPI_DEBUG_REGISTRATION_CLEAR_ALL_SEGMENTS()
#define MXMPI_DEBUG_REGISTRATION_CHECK_ALIGN(msg,ptr,len)
#endif

#endif
