/*************************************************************************
 * Myricom MPICH-MX ch_mx backend                                        *
 * Copyright (c) 2003 by Myricom, Inc.                                   *
 * All rights reserved.                                                  *
 *************************************************************************/

#ifndef _mxmpi_noreg_h
#define _mxmpi_noreg_h


#define MXMPI_BOUNCE_SEGMENT_FREE 88
#define MXMPI_BOUNCE_SEGMENT_USED 99


typedef struct bounce_buffer
{
  struct bounce_buffer *next;
  unsigned long addr;
  unsigned long data_addr;
  unsigned int length;
  unsigned int status;
} mxmpi_bounce_buffer;


void mxmpi_bounce_buffer_init(void);
void mxmpi_bounce_buffer_finish(void);
unsigned long mxmpi_allocate_bounce_buffer(unsigned long data_addr,
					  unsigned int length);
void mxmpi_free_bounce_buffer(unsigned long data_addr,
			     unsigned int length);

#endif



